local Tunnel = module('vrp', 'lib/Tunnel')
local Proxy = module('vrp', 'lib/Proxy')

local QBPhone = {}
Tunnel.bindInterface("phone", QBPhone)

local vRPclient = Tunnel.getInterface("vRP", "phone")

local vRP = Proxy.getInterface('vRP')

ServerCallbacks = {}
RegisterServerEvent("phone:triggerServerCallback")
AddEventHandler(
    "phone:triggerServerCallback",
    function(o, p, ...)
        local q = source
        TriggerServerCallback(
            o,
            p,
            q,
            function(...)
                TriggerClientEvent("phone:serverCallback", q, p, ...)
            end,
            ...
        )
    end
)

RegisterServerCallback = function(o, r)
    ServerCallbacks[o] = r
end

TriggerServerCallback = function(o, p, source, r, ...)
    if ServerCallbacks[o] then
        ServerCallbacks[o](source, r, ...)
    end
end

-- Code

GlobalState.PhoneWebhook = ""

CreateThread(function ()
    while true do
        GlobalState.TimeHourAndMinutes = os.date("%H:%M")
        Wait(1000)
    end
end)

local Tweets = {}
local AppAlerts = {}
local MentionedTweets = {}
local Hashtags = {}
local Calls = {}
local Mails = {}
local Anunturi = {
    Comerciale = {},
    Imobiliare = {},
    Vehicule = {}
}

-- Number and IBAN Generate Stuff 

function getNumberPhone(user_id)
    if user_id then
        local PhoneNumber = getUserTmpTable(user_id).phone
        return PhoneNumber
    end
    return nil
end

function getIBAN(user_id)
    if user_id then
        local iban = getUserTmpTable(user_id).iban
        Wait(50)
        return iban
    end
    return nil
end

function QBPhone.GetPlayerData()
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local PlayerData = {
            metadata = {
                phone = {profilepicture = "default", background = nil}
            },
            job = vRP.getUserFaction{user_id},
            money = {bank = vRP.getBankMoney{user_id}},
            citizenid = user_id,
            charinfo = {firstname = nil, lastname = nil, phone = nil, account = nil},
            source = player,
        }
        local identity = getUserTmpTable(user_id)
        if identity then
            PlayerData.charinfo = {firstname = identity.firstname, lastname = identity.name, phone = identity.phone, account = identity.iban}
        end
        local metadata = json.decode(identity.metadata)
        if metadata then
            if metadata.profilepicture then
                PlayerData.metadata["phone"].profilepicture = metadata.profilepicture
            end
            if metadata.background then
                PlayerData.metadata["phone"].background = metadata.background
            end
        end
        Wait(100)
        return PlayerData
    end
    return {}
end

function QBPhone.AddAdvert(type, advert)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local identity = getUserTmpTable(user_id)
        if Anunturi[type][user_id] then
            Anunturi[type][user_id].titlu = "@"..identity.firstname.." "..identity.name.." | "..identity.phone
            Anunturi[type][user_id].anunt = advert
            Anunturi[type][user_id].id = user_id
        else
            Anunturi[type][user_id] = {
                titlu = "@"..identity.firstname.." "..identity.name.." | "..identity.phone,
                anunt = advert,
                id = user_id
            }
        end
        TriggerClientEvent("phone:client:UpdateAdverts", -1, Anunturi, player, false)
    end
end

function QBPhone.RemoveAdvert(type, id)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id and user_id == id then
        Anunturi[type][id] = nil
        TriggerClientEvent("phone:client:UpdateAdverts", -1, Anunturi, player, true)
    else
        DropPlayer(player, "Bye Bye")
    end
end

function QBPhone.GetPhoneData()
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local PhoneData = {
            Applications = {},
            PlayerContacts = {},
            MentionedTweets = {},
            Chats = {},
            Hashtags = {},
			SelfTweets = {},
            Garage = {},
            Mails = {},
            Tweets = {},
            Anunturi = {
                Comerciale = {},
                Imobiliare = {},
                Vehicule = {}
            }
        }


        local contacts = exports.oxmysql:executeSync("SELECT * FROM player_contacts WHERE identifier = @user_id ORDER BY `name` ASC", {user_id = user_id})
        if contacts[1] then
            for k,v in pairs(contacts) do
                v.status = GetOnlineStatus(v.number)
            end
            PhoneData.PlayerContacts = contacts
        end

        local tweets = exports.oxmysql:executeSync("SELECT * FROM twitter_tweets")
        if tweets[1] then
            PhoneData.Tweets = tweets
        else
            PhoneData.Tweets = nil
        end

        local selftweets = exports.oxmysql:executeSync("SELECT * FROM twitter_tweets WHERE owner = @user_id", {user_id = user_id})
        if selftweets then
            PhoneData.SelfTweets = selftweets
        end

        PhoneData.Garage = {}

        local messages = exports.oxmysql:executeSync("SELECT * FROM phone_messages WHERE identifier = @user_id", {user_id = user_id})
        if messages and next(messages) then
            PhoneData.Chats = messages
        end

        if AppAlerts[user_id] then
            PhoneData.Applications = AppAlerts[user_id]
        end
        if MentionedTweets[user_id] then
            PhoneData.MentionedTweets = MentionedTweets[user_id]
        end
        if Hashtags and next(Hashtags) then
            PhoneData.Hashtags = Hashtags
        end
        if Tweets and next(Tweets) then
            PhoneData.Tweets = Tweets
        end
        if Anunturi.Comerciale and next(Anunturi.Comerciale) then
            PhoneData.Anunturi.Comerciale = Anunturi.Comerciale
        end
        if Anunturi.Vehicule and next(Anunturi.Vehicule) then
            PhoneData.Anunturi.Vehicule = Anunturi.Vehicule
        end
        if Anunturi.Imobiliare and next(Anunturi.Imobiliare) then
            PhoneData.Anunturi.Imobiliare = Anunturi.Imobiliare
        end

        if Mails[user_id] then
            PhoneData.Mails = Mails[user_id]
        end

        Wait(100)
        return PhoneData
    end
    return {}
end

function QBPhone.HasPhone()
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local HasPhone = vRP.getInventoryItemAmount{user_id, "aphone"}
        if HasPhone >=1 then
            return true
        end
    end
    return false
end

local cfg = module("vrp","cfg/garages")
local vehicle_groups = cfg.garage_types
function getVName(v)
    for _,vehicles in pairs(vehicle_groups) do
        if vehicles[v] then
            return vehicles[v][1]
        end
    end
    return "Unknown"
end

function QBPhone.GetGarageVehicles()
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local vehicles = {}
        local playerVehs = exports.oxmysql:executeSync("SELECT user_id,vehicle,vehicle_plate,confiscate FROM vrp_user_vehicles WHERE user_id = @user_id", {user_id = user_id})
        for k, v in pairs(playerVehs) do
            local vdata = {
                model = v.vehicle,
                fullname = getVName(v.vehicle),
                plate = v.vehicle_plate,
                garage = false,
                confiscata = v.confiscate,
                body = v.body or 1000
            }

            vRPclient.isPersonalVehicleSpawned(player, {"car",v.vehicle}, function(is)
                local info = is
                if info ~= nil or info == true then
                    vdata.garage = false
                else
                    vdata.garage = true
                end
            end)

            Wait(100)

            table.insert(vehicles, vdata)
        end
        return vehicles
    end
    return {}
end

function QBPhone.GetCallState(ContactData)
    local isOnline = GetPlayerByPhone(ContactData.number)
    if isOnline then
        local targetId = vRP.getUserId{isOnline}
        if targetId then
            if Calls[targetId] then
                if Calls[targetId].inCall then
                    return false, true
                else
                    return true, true
                end
            else
                return true, true
            end
        end
    end
    return false, false
end

function QBPhone.SetCallState(bool)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        if Calls[user_id] then
            Calls[user_id].inCall = bool
        else
            Calls[user_id] = {}
            Calls[user_id].inCall = bool
        end
    end
end

function QBPhone.RemoveMail(MailId)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        if not Mails[user_id] then return end;
        for i = 1, #Mails[user_id] do
            if Mails[user_id][i].mailid == MailId then
                Mails[user_id][i] = nil
            end
        end
        print(MailId,Mails[user_id])
        table.sort(Mails[user_id], function(a,b) return os.date(a.date) > os.date(b.date) end)
        TriggerClientEvent('phone:client:UpdateMails', player, Mails[user_id], false)
    end
end

function GenerateMailId()
    math.randomseed(os.time(), math.random())
    return math.random(111111, 999999)
end

RegisterServerEvent('sendNewMail')
AddEventHandler('sendNewMail', function(source,mailData)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        if not Mails[user_id] then Mails[user_id] = {} end;
        if mailData.button == nil then
            Mails[user_id][#Mails[user_id] + 1] = {
                sender = mailData.sender,
                subject = mailData.subject,
                message = mailData.message,
                read = false,
                mailid = GenerateMailId(),
                date = os.date("%c")
            }
        else
            Mails[user_id][#Mails[user_id] + 1] = {
                sender = mailData.sender,
                subject = mailData.subject,
                message = mailData.message,
                read = false,
                mailid = GenerateMailId(),
                date = os.date("%c"),
                button = mailData.button
            }
        end
        table.sort(Mails[user_id], function(a,b) return os.date(a.date) > os.date(b.date) end)
        TriggerClientEvent('phone:client:UpdateMails', player, Mails[user_id], true, mailData)
        TriggerClientEvent('phone:client:NewMailNotify', player, mailData)
    end
end)

function QBPhone.ClearButtonData(mailId)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        if not Mails[user_id] then return end;
        for i = 1, #Mails[user_id] do
            if Mails[user_id][i].mailid == mailId then
                Mails[user_id][i].button = ''
            end
        end
        table.sort(Mails[user_id], function(a,b) return os.date(a.date) < os.date(b.date) end)
        TriggerClientEvent('phone:client:UpdateMails', player, Mails[user_id], false)
    end
end


function QBPhone.MentionedPlayer(firstName, lastName, TweetMessage)
    local users = vRP.getUsers{}
    for k, v in pairs(users) do
        local identity = getUserTmpTable(k)
        if (identity.firstname == firstName and identity.name == lastName) then
            SetPhoneAlerts(k, "twitter")
            AddMentionedTweet(k, TweetMessage)
            TriggerClientEvent('phone:client:GetMentioned', v, TweetMessage, AppAlerts[k]["twitter"])
        else
            local result = exports.oxmysql:executeSync("SELECT id FROM vrp_users WHERE firstName = @firstname AND lastName = @lastname", {firstname = firstName, lastname = lastName})
            if result[1] then
                local MentionedTarget = result[1].id
                SetPhoneAlerts(MentionedTarget, "twitter")
                AddMentionedTweet(MentionedTarget, TweetMessage)
            end
        end
	end
end

function QBPhone.CallContact(TargetData, CallId, AnonymousCall)
    if TargetData.number:find("#31#") then TargetData.number = TargetData.number:gsub("#31#", "") AnonymousCall = true end;
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local target = GetPlayerByPhone(TargetData.number)
        if target then
            local identity = getUserTmpTable(user_id)
            Wait(100)
            TriggerClientEvent('phone:client:GetCalled', target, identity.phone, CallId, AnonymousCall)
        end
    end
end

function QBPhone.UpdateHashtags(Handle, messageData)
    if Hashtags[Handle] then
        Hashtags[Handle].messages[#Hashtags[Handle].messages + 1] = messageData
    else
        Hashtags[Handle] = {
            hashtag = Handle,
            messages = {}
        }
        Hashtags[Handle].messages[#Hashtags[Handle].messages + 1] = messageData
    end
    TriggerClientEvent('phone:client:UpdateHashtags', -1, Handle, messageData)
end

function QBPhone.deleteWapp(ChatNumber)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        exports.oxmysql:execute("DELETE FROM phone_messages WHERE identifier = @identifier AND number = @number", {identifier = user_id, number = ChatNumber})
    end
end

function QBPhone.deleteTweet(id, NewTweets)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        exports.oxmysql:execute("DELETE FROM twitter_tweets WHERE owner = @owner AND id = @id", {owner = user_id, id = id})
        TriggerClientEvent('phone:client:UpdateTweets', -1, player, NewTweets, nil, true)
    end
end

function QBPhone.UpdateTweets(NewTweets, TweetData)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        Tweets = NewTweets
        exports.oxmysql:execute('INSERT INTO twitter_tweets (firstname, lastname, message, url, time, picture, owner) VALUES (@firstname, @lastname, @message, @url, @time, @picture, @owner)', {firstname = TweetData.firstName, lastname = TweetData.lastName, message = TweetData.message, url = TweetData.url, time = TweetData.time, picture = TweetData.picture, owner = user_id})
        TriggerClientEvent('phone:client:UpdateTweets', -1, player, NewTweets, TweetData, false)
    end
end

function QBPhone.UpdateMessages(ChatMessages, ChatNumber, New)
    if ChatNumber == 911 or ChatNumber == 112 then return end;
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        vRP.getUserByPhone{ChatNumber, function (targetId)
            local targetSource = vRP.getUserSource{targetId}
            local tidentity = getUserTmpTable(targetId)
            local identity = getUserTmpTable(user_id)
            if targetSource then
                Wait(100)
                local Chat = exports.oxmysql:executeSync("SELECT * FROM `phone_messages` WHERE `identifier` = @identifier AND `number` = @number", {identifier = user_id, number = ChatNumber})
                if Chat[1] then
                    -- Update for target
                    Wait(50)
                    exports.oxmysql:execute("UPDATE `phone_messages` SET `messages` = @messages WHERE `identifier` = @identifier AND `number` = @number", {messages = json.encode(ChatMessages), identifier = targetId, number = identity.phone})
                    -- Update for sender
                    Wait(50)
                    exports.oxmysql:execute("UPDATE `phone_messages` SET `messages` = @messages WHERE `identifier` = @identifier AND `number` = @number", {messages = json.encode(ChatMessages), identifier = user_id, number = tidentity.phone})
                    -- Send notification & Update messages for target
                    TriggerClientEvent('phone:client:UpdateMessages', targetSource, ChatMessages, identity.phone, false)
                else
                    -- Insert for target
                    Wait(50)
                    exports.oxmysql:execute("INSERT INTO `phone_messages` (`identifier`, `number`, `messages`) VALUES (@identifier, @number, @messages)", {identifier = targetId, number = identity.phone, messages = json.encode(ChatMessages)})
                    -- Insert for sender
                    Wait(50)
                    exports.oxmysql:execute("INSERT INTO `phone_messages` (`identifier`, `number`, `messages`) VALUES (@identifier, @number, @messages)", {identifier = user_id, number = tidentity.phone, messages = json.encode(ChatMessages)})
                    -- Send notification & Update messages for target
                    TriggerClientEvent('phone:client:UpdateMessages', targetSource, ChatMessages, identity.phone, true)
                end
            else
                Wait(100)
                local Chat = exports.oxmysql:executeSync("SELECT * FROM `phone_messages` WHERE `identifier` = @identifier AND `number` = @number", {identifier = user_id, number = ChatNumber})
                if Chat[1] then
                    -- Update for target
                    Wait(50)
                    exports.oxmysql:execute("UPDATE `phone_messages` SET `messages` = @messages WHERE `identifier` = @identifier AND `number` = @number", {messages = json.encode(ChatMessages), identifier = targetId, number = identity.phone})
                    -- Update for sender
                    Wait(50)
                    exports.oxmysql:execute("UPDATE `phone_messages` SET `messages` = @messages WHERE `identifier` = @identifier AND `number` = @number", {messages = json.encode(ChatMessages), identifier = user_id, number = ChatNumber})
                else
                    -- Insert for target
                    Wait(50)
                    exports.oxmysql:execute("INSERT INTO `phone_messages` (`identifier`, `number`, `messages`) VALUES (@identifier, @number, @messages)", {identifier = targetId, number = identity.phone, messages = json.encode(ChatMessages)})
                    -- Insert for sender
                    Wait(50)
                    exports.oxmysql:execute("INSERT INTO `phone_messages` (`identifier`, `number`, `messages`) VALUES (@identifier, @number, @messages)", {identifier = user_id, number = tidentity.phone, messages = json.encode(ChatMessages)})
                end
            end
        end}
    end
end

function AddMentionedTweet(user_id, TweetData)
    if MentionedTweets[user_id] == nil then MentionedTweets[user_id] = {} end
    MentionedTweets[user_id][#MentionedTweets[user_id] + 1] = TweetData
end

function SetPhoneAlerts(user_id, app, alerts)
    if user_id ~= nil and app ~= nil then
        if AppAlerts[user_id] == nil then
            AppAlerts[user_id] = {}
            if AppAlerts[user_id][app] == nil then
                if alerts == nil then
                    AppAlerts[user_id][app] = 1
                else
                    AppAlerts[user_id][app] = alerts
                end
            end
        else
            if AppAlerts[user_id][app] == nil then
                if alerts == nil then
                    AppAlerts[user_id][app] = 1
                else
                    AppAlerts[user_id][app] = 0
                end
            else
                if alerts == nil then
                    AppAlerts[user_id][app] = AppAlerts[user_id][app] + 1
                else
                    AppAlerts[user_id][app] = AppAlerts[user_id][app] + 0
                end
            end
        end
    end
end

function QBPhone.GetContactPictures(Chats)
    for k, v in pairs(Chats) do
        local result = exports.oxmysql:executeSync("SELECT metadata FROM vrp_user_identities WHERE phone = @phoneNumber", {phoneNumber = v.number})[1].metadata
        if result then
                v.picture = "default"
        end
    end
    Wait(100)
    return Chats
end

function QBPhone.GetContactPicture(Chat)
    local result = exports.oxmysql:executeSync("SELECT metadata FROM vrp_user_identities WHERE phone = @phoneNumber", {phoneNumber = Chat.number})[1].metadata
    if result then
        Chat.picture = "default"
    end
    Wait(100)
    return Chat
end

function QBPhone.GetPicture(number)
    local Picture = nil
    local result = exports.oxmysql:executeSync("SELECT metadata FROM vrp_user_identities WHERE phone = @phoneNumber", {phoneNumber = number})[1].metadata
    if result then
        Picture = "default"
        return Picture
    end
    return nil
end

--URAT DAR N-AVEM CE FACE!!!
function QBPhone.TransferMoney(iban, amount)
    local player = source
    local user_id = vRP.getUserId{player}
    local cbdata = {
        CanTransfer = false,
        NewAmount = nil,
        isOnline = false
    }
    if user_id and iban then
        local reciver = GetPlayerByIban(iban)
        if not reciver then return vRPclient.notify(player,{"Acest IBAN nu exista!"}) end;
        if reciver == user_id then return vRPclient.notify(player,{"Nu iti transfera bani tie!"}) end;
        local ron = vRP.getUserSource{reciver}
            if vRP.tryWithdraw{user_id, amount} then -- withdraw to complete amount
            vRP.tryPayment{user_id, amount}
            local bankMoney = vRP.getBankMoney{reciver}
            cbdata.CanTransfer = true
            cbdata.NewAmount = bankMoney - amount
            cbdata.isOnline = false
            if ron then
                local count = vRP.getInventoryItemAmount{reciver, "aphone"}
                if count >= 1 then
                    local rbank = bankMoney
                    TriggerClientEvent('phone:client:TransferMoney', ron, amount, rbank)
                end
                
                cbdata.isOnline = true
                vRP.giveBankMoney{reciver, amount}
            else
                exports.oxmysql:execute("UPDATE vrp_users SET walletMoney = walletMoney + @amount WHERE id = @user_id", {user_id = reciver, amount = amount})
            end
            vRPclient.notify(player, {"~y~Ai transferat cu succes ~g~" .. amount .. " ~y~LEI."})
            return cbdata
        else
            if ron then
                cbdata.isOnline = true
            end
        end
    end
    return cbdata
end

function QBPhone.AddRecentCall(type, data, anonymous)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local label = os.date("%H:%M")
        TriggerClientEvent('phone:client:AddRecentCall', player, data, label, type)
        local target = GetPlayerByPhone(data.number)
        if target then
            local identity = getUserTmpTable(user_id)
            TriggerClientEvent('phone:client:AddRecentCall', target, {
                name = identity.firstname .. " " ..identity.name,
                number = identity.phone,
                anonymous = anonymous
            }, label, "outgoing")
        end
    end
end

function QBPhone.CancelCall(CallData)
    local player = GetPlayerByPhone(CallData.TargetData.number)
    if player then
        TriggerClientEvent('phone:client:CancelCall', player)
    end
end

function QBPhone.AnswerCall(CallData)
    local player = GetPlayerByPhone(CallData.TargetData.number)
    if player then
        TriggerClientEvent('phone:client:AnswerCall', player)
    end
end

function QBPhone.SaveMetaData(MData)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local MetaData = json.decode(getUserTmpTable(user_id).metadata)
        if MetaData then
            MetaData.profilepicture = MData.profilepicture
            MetaData.background = MData.background
        end
        exports.oxmysql:execute("UPDATE vrp_user_identities SET metadata = @metadata WHERE user_id = @user_id", {user_id = user_id, metadata = json.encode(MData)})
    end
end

function QBPhone.EditContact(newName, newNumber, newIban, oldName, oldNumber, oldIban)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        exports.oxmysql:execute("UPDATE `player_contacts` SET `name` = @newName, `number` = @newNumber, `iban` = @newIban WHERE `identifier` = @identifier AND `name` = @oldName AND `number` = @oldNumber AND `iban` = @oldIban", {newName = newName, newNumber = newNumber, newIban = newIban, identifier = user_id, oldName = oldName, oldNumber = oldNumber, oldIban = oldIban})
    end
end

function QBPhone.RemoveContact(Name, Number)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        exports.oxmysql:execute("DELETE FROM `player_contacts` WHERE `name` = @name AND `number` = @number AND `identifier` = @identifier", {name = Name, number = Number, identifier = user_id})
    end
end

function QBPhone.AddNewContact(name, number, iban)
    if number == 911 or number == 112 then return end;
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        exports.oxmysql:execute("INSERT INTO `player_contacts` (`identifier`, `name`, `number`, `iban`) VALUES (@identifier, @name, @number, @iban)", {identifier = user_id, name = tostring(name), number = tostring(number), iban = tostring(iban)})
    end
end

function QBPhone.shareContact()
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local identity = getUserTmpTable(user_id)
        local SuggestionData = {
            name = {
                [1] = identity.firstname,
                [2] = identity.name
            },
            number = identity.phone,
            bank = identity.iban
        }
        vRPclient.getNearestPlayers(player, {5}, function (players)
            if json.encode(players) ~= "[]" then
                for k,v in pairs(players) do                
                    TriggerClientEvent('phone:client:AddNewSuggestion', k, SuggestionData)
                end
            else
                vRPclient.notify(player, {"Nimeni in jurul tau."})
            end
        end)
    end
end

function GetPlayerByIban(iban)
    if iban then
        local result = exports.oxmysql:executeSync("SELECT user_id FROM vrp_user_identities WHERE iban = @iban", {iban = iban})
        if #result > 0 then
            local id = result[1].user_id
            return id
        else
            return nil
        end
    end
end

function QBPhone.SetPhoneAlerts(app, alerts)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        SetPhoneAlerts(user_id, app, alerts)
    end
end

function QBPhone.GetCurrentMechanic()
    local Mechanic = {}
    local mecanici = vRP.getOnlineUsersByFaction{"Mecanic"}
    for k, v in pairs(mecanici) do
        local identity = getUserTmpTable(v)
        Mechanic[#Mechanic + 1] = {
            name = identity.firstname .. " " .. identity.name,
            phone = identity.phone,
        }
    end
    Wait(200)
    return Mechanic
end

function QBPhone.GetCurrentDrivers()
    local Taxi = {}
    local taximetristi = vRP.getOnlineUsersByFaction{"Taxi"}
    for k, v in pairs(taximetristi) do
        local identity = getUserTmpTable(v)
        Taxi[#Taxi + 1] = {
            name = identity.firstname .. " " .. identity.name,
            phone = identity.phone,
        }
    end
    Wait(500)
    return Taxi
end

function QBPhone.GetCurrentPolices()
    local Polices = {}
    local politisti = vRP.getOnlineUsersByFaction{"Politie"}
    for k, v in pairs(politisti) do
        local identity = getUserTmpTable(v)
        vRP.getUserIdentity({v, function(identity)
            if identity then
                Polices[#Polices + 1] = {
                    name = identity.firstname .. " " .. identity.name,
                    phone = identity.phone,
                }
            end
        end})
    end
    Wait(200)
    return Polices
end

function QBPhone.GetCurrentDoctors()
    local Doctors = {}
    local politisti = vRP.getOnlineUsersByFaction{"Smurd"}
    for k, v in pairs(politisti) do
        local identity = getUserTmpTable(v)
        Doctors[#Doctors + 1] = {
            name = identity.firstname .. " " .. identity.name,
            phone = identity.phone,
        }
    end
    Wait(200)
    return Doctors
end

RegisterServerCallback("answerMecanic", function(player, cb, number)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local ts = GetPlayerByPhone(number)
        if ts then
            local ti = vRP.getUserId{ts}
            if vRP.isUserInFaction{ti, "Mecanic"} then
                vRP.request{ts, "Mecanici: Comanda primita. Accepti?", 15, function(ts, ok)
                    cb(ok)
                end}
            end
        end
    end
end)


RegisterServerCallback("answerDriver", function(player, cb, number)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local ts = GetPlayerByPhone(number)
        if ts then
            local ti = vRP.getUserId{ts}
            local user_id = vRP.getUserId(player)
            if vRP.isUserInFaction{ti, "Taxi"} then
                vRP.request{ts, "Taxi: Comanda primita. Accepti?", 15, function(ts, ok)
                    cb(ok)
                end}
            end
        end
    end
end)

RegisterServerCallback("answerPolice", function(player, cb, number)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local ts = GetPlayerByPhone(number)
        if ts then
            local ti = vRP.getUserId{ts}
            if vRP.isUserInFaction{ti, "Politie"} then
                vRP.request{ts, "Politie: Apel primit. Raspunzi?", 15, function(ts, ok)
                    cb(ok)
                end}
            end
        end
    end
end)

RegisterServerCallback("answerDoctor", function(player, cb, number)
    local player = source
    local user_id = vRP.getUserId{player}
    if user_id then
        local ts = GetPlayerByPhone(number)
        if ts then
            local ti = vRP.getUserId{ts}
            if vRP.isUserInFaction{ti, "Smurd"} then
                vRP.request{ts, "Medici: Apel primit. Raspunzi?", 15, function(ts, ok)
                    cb(ok)
                end}
            end
        end
    end
end)

function GetOnlineStatus(number)
    if number then
        local isOnline = GetPlayerByPhone(number)
        if isOnline then
            return true
        end
    end
    return false
end

function GetPlayerByPhone(number)
    local pSource = nil
    vRP.getUserByPhone{number, function (targetId)
        local targetSource = vRP.getUserSource{targetId}
        if targetSource then
            pSource = targetSource
        end
    end}
    Wait(100)
    return pSource
end

function getUserTmpTable(user_id)
    if user_id == nil then return end;
    local tempTable = {}
    vRP.getUserIdentity{user_id, function (identity)
        tempTable = identity
    end}
    Wait(100)
    return tempTable
end